using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Contabilidad._0_Modelos;
using Exferia_Aplicacion.Modelos_MantenimientoSimple;
using System.Transactions;
using System.Data.SqlClient;
using System.Linq.Expressions;
using System.ComponentModel;
using static Exferia_Aplicacion.General.Enumerados;
using System.Threading;
using Exferia_Aplicacion.Modelos_Contabilidad;

namespace Exferia_Contabilidad._1_Datos
{
    class CTA_InformesContablesLineaDesglose_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }

        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;

        }

        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener
        #region Obtener principal
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 2;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];
        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                    " SELECT " +
                        nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.id) + " , " +
                        nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idInformeContableLinea) + " , " +
                        nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idMayor) + " , " +
                        nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idPlanGeneralContable) + " , " +
                        nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.linea) + " , " +
                        nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.fechaActualizacionInterna) + " , " +
                        nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.control_DebeHaber) + " , " +
                        nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.fechaBorrado) + 
                    " FROM " + nameof(CTA_InformesContablesLineaDesglose) +
                    " WHERE " + nameof(CTA_InformesContablesLineaDesglose.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<CTA_InformesContablesLineaDesglose>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //CTA_Mayor ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idMayor!=null)
                    {
                        ThreadStart obj_ThreadStart_MAYOR= new ThreadStart(Obtener_Mayor_Modelo_Obtener);
                        Thread obj_Thread_MAYOR = new Thread(obj_ThreadStart_MAYOR);
                        obj_Thread_MAYOR.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //CTA_PlanGeneralContable ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idPlanGeneralContable != null)
                    {
                        ThreadStart obj_ThreadStart_PLANGENERALCONTABLE = new ThreadStart(Obtener_PlanGeneralContable_Modelo_Obtener);
                        Thread obj_Thread_PLANGENERALCONTABLE = new Thread(obj_ThreadStart_PLANGENERALCONTABLE);
                        obj_Thread_PLANGENERALCONTABLE.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[1] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        #region Tablas Relacionadas
        private void Obtener_Mayor_Modelo_Obtener()
        {
            try
            {
                CTA_Mayor_Datos obj_CTA_Mayor_Datos = new CTA_Mayor_Datos();
                g_dnm_Modelo_Obtener.CTA_Mayor = obj_CTA_Mayor_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idMayor);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_PlanGeneralContable_Modelo_Obtener()
        {
            try
            {
                CTA_PlanGeneralContable_Datos obj_CTA_PlanGeneralContable_Datos = new CTA_PlanGeneralContable_Datos();
                g_dnm_Modelo_Obtener.CTA_PlanGeneralContable = obj_CTA_PlanGeneralContable_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idPlanGeneralContable);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        #endregion

        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        public int Obtener_UltimoNumeroLinea(long _lng_idInformeContableLinea)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            int int_Linea = 0;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                 string str_SQL =
                                " SELECT TOP 1 " +
                                    nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.linea) +
                                " FROM " + nameof(CTA_InformesContablesLineaDesglose) +
                                " WHERE " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.fechaBorrado) + " is null and " +
                                            nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idInformeContableLinea) + "=@idInformeContableLinea " +
                                " ORDER BY " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.linea) + " DESC ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idInformeContableLinea",  _lng_idInformeContableLinea)
                };

                int? int_linea_AUX = obj_Exferia_Entities.Database.SqlQuery<int>(str_SQL, arr_Parametros).FirstOrDefault();

                if (int_linea_AUX != null)
                {
                    int_Linea = int_linea_AUX.Value;
                }

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Obtener_UltimoNumeroLinea), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return int_Linea;
        }

        public bool Existe_NumeroLinea(long _lng_idInformeContableLinea, long _lng_idInformeContableLineaDesglose_Obviar, int _int_Linea)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            bool bol_Existe = false;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                                " SELECT TOP 1 " +
                                    nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.id) +
                                " FROM " + nameof(CTA_InformesContablesLineaDesglose) +
                                " WHERE " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.fechaBorrado) + " is null and " +
                                            nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.id) + "<>@id and " +
                                            nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idInformeContableLinea) + "=@idInformeContableLinea and " +
                                            nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.linea) + "=@linea ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_idInformeContableLineaDesglose_Obviar),
                     new SqlParameter("@idInformeContableLinea",  _lng_idInformeContableLinea),
                     new SqlParameter("@linea",  _int_Linea)
                };

                long? lng_Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL, arr_Parametros).FirstOrDefault();

                if (lng_Id != null && lng_Id.Value > 0)
                {
                    bol_Existe = true;
                }

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Existe_NumeroLinea), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return bol_Existe;
        }

        #region Para Listado
        public List<INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo> Obtener_Registros_Para_Listado_Por_IdInformeContableLinea(long _lng_idInformeContableLinea)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo> lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                string str_SQL = Obtener_Consulta_Para_Listado();

                string str_Where =  nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.fechaBorrado) + " is null and " +
                                    nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idInformeContableLinea) + "=@idInformeContableLinea";

                str_SQL = str_SQL.Replace("XXXXXXXXXX", str_Where);

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idInformeContableLinea",  _lng_idInformeContableLinea)
                };

                //Rellenar el Modelo
                lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Obtener_Registros_Para_Listado_Por_IdInformeContableLinea), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo;
        }
        public List<INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo> Obtener_Registros_Para_Listado_Por_UltimaFechaActualizacion(long _lng_idInformeContableLinea, DateTime? _dtt_Ultima_FechaActualizacion)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo> lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                string str_SQL = Obtener_Consulta_Para_Listado();

                
                //where
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                lst_Parametros.Add(new SqlParameter("@idInformeContableLinea", _lng_idInformeContableLinea));

                string str_Where =  " (not " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.fechaActualizacionInterna) + "  is null) AND " + 
                                    nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idInformeContableLinea) + " =@idInformeContableLinea ";

                if (_dtt_Ultima_FechaActualizacion != null)
                {
                    str_Where += " AND convert(varchar, " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.fechaActualizacionInterna) + ",20)>=@FechaUltimaFechaActualizacion ";
                    lst_Parametros.Add(new SqlParameter("@FechaUltimaFechaActualizacion", _dtt_Ultima_FechaActualizacion.Value.ToString("yyyy-MM-dd HH:mm:ss")));
                }
                str_SQL = str_SQL.Replace("XXXXXXXXXX", str_Where);

                //Parametros
                object[] arr_Parametros = lst_Parametros.ToArray();


                //Rellenar el Modelo
                lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Obtener_Registros_Para_Listado_Por_UltimaFechaActualizacion), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo;
        }

        private string Obtener_Consulta_Para_Listado()
        {
            return 
                  " SELECT " +
                            nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.id) + " = " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.id) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.idInformeContableLinea) + " = " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idInformeContableLinea) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.linea) + " = " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.linea) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.idMayor) + " = " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idMayor) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.idPlanGeneralContable) + " = " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idPlanGeneralContable) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.control_DebeHaber) + " = " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.control_DebeHaber) + " , " +
                            nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.fechaActualizacionInterna) + " = " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.fechaActualizacionInterna) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.fechaBorrado) + " =  " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.fechaBorrado) + ", " +
                            //CTA_Mayor
                            nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.Mayor_Codigo) + " = " + nameof(CTA_Mayor) + "." + nameof(CTA_Mayor.codigo) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.Mayor_Descripcion) + " = " + nameof(CTA_Mayor) + "." + nameof(CTA_Mayor.descripcion) + "," +
                            //CTA_PlanGeneralContable
                            nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.PlanGeneralContable_Codigo) + " = " + nameof(CTA_PlanGeneralContable) + "." + nameof(CTA_PlanGeneralContable.codigo) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.PlanGeneralContable_Descripcion) + " = " + nameof(CTA_PlanGeneralContable) + "." + nameof(CTA_PlanGeneralContable.descripcion) + 
                        " FROM " + nameof(CTA_InformesContablesLineaDesglose) +
                        " LEFT JOIN " + nameof(CTA_Mayor) + " ON " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idMayor) + " = " + nameof(CTA_Mayor) + "." + nameof(CTA_Mayor.id) +
                        " LEFT JOIN " + nameof(CTA_PlanGeneralContable) + " ON " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idPlanGeneralContable) + " = " + nameof(CTA_PlanGeneralContable) + "." + nameof(CTA_PlanGeneralContable.id) +
                        //Where
                        " WHERE XXXXXXXXXX";
        }

        #endregion
        #endregion

        #region MODELOS

        #region Modelo Simple
        private CTA_InformesContablesLineaDesglose g_mdl_CTA_InformesContablesLineaDesglose = null;
        public CTA_InformesContablesLineaDesglose Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_CTA_InformesContablesLineaDesglose;
        }

        #region Ejecutar_Consulta_Modelo
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_CTA_InformesContablesLineaDesglose = obj_Exferia_Entities.Database.SqlQuery<CTA_InformesContablesLineaDesglose>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }



        #endregion
        #endregion

        #region ModeloListado
        private List<CTA_InformesContablesLineaDesglose> g_lst_CTA_InformesContablesLineaDesglose = null;

        public List<CTA_InformesContablesLineaDesglose> Obtener_ModeloListado_Por_IdInformeContableLinea( long _lng_idInformeContableLinea,
                                                                                                            bool _bol_Cargar_Mayor,
                                                                                                            bool _bol_Cargar_PlanGeneralContable)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idInformeContableLinea) + "=@idInformeContableLinea";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idInformeContableLinea",  _lng_idInformeContableLinea)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros,
                                                 _bol_Cargar_Mayor,
                                                 _bol_Cargar_PlanGeneralContable);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdInformeContableLinea), true);
            }

            return g_lst_CTA_InformesContablesLineaDesglose;
        }

        public List<CTA_InformesContablesLineaDesglose> Obtener_ModeloListado_Por_IdsInformeContableLinea(List<long> _lst_idInformeContableLinea,
                                                                                                          bool _bol_Cargar_Mayor,
                                                                                                          bool _bol_Cargar_PlanGeneralContable)
        {
            try
            {
                if (_lst_idInformeContableLinea!=null && _lst_idInformeContableLinea.Count>0)
                {

                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(CTA_InformesContablesLineaDesglose),
                                                                                           nameof(CTA_InformesContablesLineaDesglose.idInformeContableLinea),
                                                                                           G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                           _lst_idInformeContableLinea);


                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE " + nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.fechaBorrado) + " is null and " +
                                       str_Filtros_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { },
                                                     _bol_Cargar_Mayor,
                                                     _bol_Cargar_PlanGeneralContable);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdsInformeContableLinea), true);
            }

            return g_lst_CTA_InformesContablesLineaDesglose;
        }

        #region Ejecutar Consulta

        //Listado de modelos Relacionados
        private List<CTA_Mayor> g_lst_CTA_Mayor = null;
        private List<CTA_PlanGeneralContable> g_lst_CTA_PlanGeneralContable = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 2;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros,
                                                      bool _bol_Cargar_Mayor,
                                                      bool _bol_Cargar_PlanGeneralContable)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_CTA_InformesContablesLineaDesglose = obj_Exferia_Entities.Database.SqlQuery<CTA_InformesContablesLineaDesglose>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar tablas Relacionadas
                if (g_lst_CTA_InformesContablesLineaDesglose != null && g_lst_CTA_InformesContablesLineaDesglose.Count > 0)
                {
                   
                    //Si tiene que buscar alguna tabla relacionada
                    if (_bol_Cargar_Mayor ||
                    _bol_Cargar_PlanGeneralContable)
                    {
                        #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                        }

                        //CTA_Mayor #############################################
                        if (_bol_Cargar_Mayor)
                        {
                            ThreadStart obj_ThreadStart_MAYOR = new ThreadStart(Obtener_Mayor_Modelo_Listado);
                            Thread obj_Thread_MAYOR = new Thread(obj_ThreadStart_MAYOR);
                            obj_Thread_MAYOR.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                        }

                        //CTA_PlanGeneralContable #############################################
                        if (_bol_Cargar_PlanGeneralContable)
                        {
                            ThreadStart obj_ThreadStart_PLANGENERALCONTABLE = new ThreadStart(Obtener_PlanGeneralContable_Modelo_Listado);
                            Thread obj_Thread_PLANGENERALCONTABLE = new Thread(obj_ThreadStart_PLANGENERALCONTABLE);
                            obj_Thread_PLANGENERALCONTABLE.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[1] = true;
                        }


                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................
                        #endregion

                        #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                        foreach (CTA_InformesContablesLineaDesglose mdl_CTA_InformesContablesLineaDesglose in g_lst_CTA_InformesContablesLineaDesglose)
                        {
                            //CTA_Mayor #############################################
                            if (_bol_Cargar_Mayor &&
                                mdl_CTA_InformesContablesLineaDesglose.idMayor != null &&
                                g_lst_CTA_Mayor != null &&
                                g_lst_CTA_Mayor.Count > 0)
                            {
                                mdl_CTA_InformesContablesLineaDesglose.CTA_Mayor = g_lst_CTA_Mayor.Where(m => m.id == mdl_CTA_InformesContablesLineaDesglose.idMayor.Value).FirstOrDefault();
                            }

                            //CTA_PlanGeneralContable #############################################
                            if (_bol_Cargar_PlanGeneralContable &&
                                mdl_CTA_InformesContablesLineaDesglose.idPlanGeneralContable != null &&
                                g_lst_CTA_PlanGeneralContable != null &&
                                g_lst_CTA_PlanGeneralContable.Count > 0)
                            {
                                mdl_CTA_InformesContablesLineaDesglose.CTA_PlanGeneralContable = g_lst_CTA_PlanGeneralContable.Where(m => m.id == mdl_CTA_InformesContablesLineaDesglose.idPlanGeneralContable.Value).FirstOrDefault();
                            }
                        }
                        #endregion
                    }
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #region Tablas Relacionadas
        private void Obtener_Mayor_Modelo_Listado()
        {
            try
            {
                CTA_Mayor_Datos obj_CTA_Mayor_Datos = new CTA_Mayor_Datos();
                g_lst_CTA_Mayor = obj_CTA_Mayor_Datos.Obtener_ModeloListado_Por_Ids(g_lst_CTA_InformesContablesLineaDesglose.Where(m=>m.idMayor!=null).Select(m => m.idMayor.Value).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        private void Obtener_PlanGeneralContable_Modelo_Listado()
        {
            try
            {
                CTA_PlanGeneralContable_Datos obj_CTA_PlanGeneralContable_Datos = new CTA_PlanGeneralContable_Datos();
                g_lst_CTA_PlanGeneralContable= obj_CTA_PlanGeneralContable_Datos.Obtener_ModeloListado_Por_Ids(g_lst_CTA_InformesContablesLineaDesglose.Where(m => m.idPlanGeneralContable != null).Select(m => m.idPlanGeneralContable.Value).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[1] = true;
            }
        }
        #endregion
        #endregion


        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.id) + " , " +
                    nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idInformeContableLinea) + " , " +
                    nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idMayor) + " , " +
                    nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.idPlanGeneralContable) + " , " +
                    nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.control_DebeHaber) + " , " +
                    nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.linea) + " , " +
                    nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.fechaActualizacionInterna) + " , " +
                    nameof(CTA_InformesContablesLineaDesglose) + "." + nameof(CTA_InformesContablesLineaDesglose.fechaBorrado) +
                " FROM " + nameof(CTA_InformesContablesLineaDesglose);
        }
        #endregion
    
        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                CTA_InformesContablesLineaDesglose mdl_CTA_InformesContablesLineaDesglose_AGrabar = (CTA_InformesContablesLineaDesglose)_mdl_obj;
                CTA_InformesContablesLineaDesglose mdl_CTA_InformesContablesLineaDesglose_DatosViejos = new CTA_InformesContablesLineaDesglose();

                // Ver si existe ######################################################################
                CTA_InformesContablesLineaDesglose mdl_CTA_InformesContablesLineaDesglose_Final = Obtener_Modelo_Por_Id(mdl_CTA_InformesContablesLineaDesglose_AGrabar.id);
                //######################################################################################

                if (mdl_CTA_InformesContablesLineaDesglose_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_CTA_InformesContablesLineaDesglose_Final, mdl_CTA_InformesContablesLineaDesglose_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CTA_InformesContablesLineaDesglose_AGrabar, mdl_CTA_InformesContablesLineaDesglose_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CTA_InformesContablesLineaDesglose) +
                                            " SET " +
                                                 nameof(CTA_InformesContablesLineaDesglose.idInformeContableLinea) + "=@idInformeContableLinea, " +
                                                 nameof(CTA_InformesContablesLineaDesglose.idMayor) + "=@idMayor, " +
                                                 nameof(CTA_InformesContablesLineaDesglose.idPlanGeneralContable) + "=@idPlanGeneralContable, " +
                                                 nameof(CTA_InformesContablesLineaDesglose.control_DebeHaber) + "=@control_DebeHaber, " +
                                                 nameof(CTA_InformesContablesLineaDesglose.linea) + "=@linea, " +
                                                nameof(CTA_InformesContablesLineaDesglose.fechaActualizacionInterna) + "=getdate()," +
                                                nameof(CTA_InformesContablesLineaDesglose.fechaBorrado) + "=@fechaBorrado " +
                                                " WHERE " +
                                                nameof(CTA_InformesContablesLineaDesglose.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@idInformeContableLinea",  mdl_CTA_InformesContablesLineaDesglose_Final.idInformeContableLinea),
                        mdl_CTA_InformesContablesLineaDesglose_Final.idMayor!=null
                            ?   new SqlParameter("@idMayor", mdl_CTA_InformesContablesLineaDesglose_Final.idMayor.Value)
                            :   new SqlParameter("@idMayor",  DBNull.Value),
                        mdl_CTA_InformesContablesLineaDesglose_Final.idPlanGeneralContable!=null
                            ?   new SqlParameter("@idPlanGeneralContable", mdl_CTA_InformesContablesLineaDesglose_Final.idPlanGeneralContable.Value)
                            :   new SqlParameter("@idPlanGeneralContable",  DBNull.Value),
                         mdl_CTA_InformesContablesLineaDesglose_Final.control_DebeHaber!=null
                            ?   new SqlParameter("@control_DebeHaber", mdl_CTA_InformesContablesLineaDesglose_Final.control_DebeHaber)
                            :   new SqlParameter("@control_DebeHaber",  DBNull.Value),
                        new SqlParameter("@linea",  mdl_CTA_InformesContablesLineaDesglose_Final.linea),
                        mdl_CTA_InformesContablesLineaDesglose_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_CTA_InformesContablesLineaDesglose_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_CTA_InformesContablesLineaDesglose_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_CTA_InformesContablesLineaDesglose_Final.id;
                }
                else
                {
                    mdl_CTA_InformesContablesLineaDesglose_Final = new CTA_InformesContablesLineaDesglose();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CTA_InformesContablesLineaDesglose_AGrabar, mdl_CTA_InformesContablesLineaDesglose_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(CTA_InformesContablesLineaDesglose) +
                                                " (" +
                                                        nameof(CTA_InformesContablesLineaDesglose.idInformeContableLinea) + "," +
                                                        nameof(CTA_InformesContablesLineaDesglose.idMayor) + "," +
                                                        nameof(CTA_InformesContablesLineaDesglose.idPlanGeneralContable) + "," +
                                                        nameof(CTA_InformesContablesLineaDesglose.control_DebeHaber) + "," +
                                                        nameof(CTA_InformesContablesLineaDesglose.linea) + "," +
                                                        nameof(CTA_InformesContablesLineaDesglose.fechaActualizacionInterna) + "," +
                                                        nameof(CTA_InformesContablesLineaDesglose.fechaBorrado) + 
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(CTA_InformesContablesLineaDesglose.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@idInformeContableLinea," +
                                                    "@idMayor," +
                                                    "@idPlanGeneralContable," +
                                                    "@control_DebeHaber," +
                                                    "@linea," +
                                                    "getdate()," +
                                                    "@fechaBorrado" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idInformeContableLinea",  mdl_CTA_InformesContablesLineaDesglose_Final.idInformeContableLinea),
                        mdl_CTA_InformesContablesLineaDesglose_Final.idMayor!=null
                            ?   new SqlParameter("@idMayor", mdl_CTA_InformesContablesLineaDesglose_Final.idMayor.Value)
                            :   new SqlParameter("@idMayor",  DBNull.Value),
                        mdl_CTA_InformesContablesLineaDesglose_Final.idPlanGeneralContable!=null
                            ?   new SqlParameter("@idPlanGeneralContable", mdl_CTA_InformesContablesLineaDesglose_Final.idPlanGeneralContable.Value)
                            :   new SqlParameter("@idPlanGeneralContable",  DBNull.Value),
                         mdl_CTA_InformesContablesLineaDesglose_Final.control_DebeHaber!=null
                            ?   new SqlParameter("@control_DebeHaber", mdl_CTA_InformesContablesLineaDesglose_Final.control_DebeHaber)
                            :   new SqlParameter("@control_DebeHaber",  DBNull.Value),
                        new SqlParameter("@linea",  mdl_CTA_InformesContablesLineaDesglose_Final.linea),
                        mdl_CTA_InformesContablesLineaDesglose_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_CTA_InformesContablesLineaDesglose_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTA_InformesContablesLineaDesglose), mdl_CTA_InformesContablesLineaDesglose_DatosViejos, mdl_CTA_InformesContablesLineaDesglose_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public void Actualizar_FechaActualizacionInterna(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                #region Update
                string str_SQL_Update = " UPDATE " + nameof(CTA_InformesContablesLineaDesglose) +
                                            " SET " +
                                                nameof(CTA_InformesContablesLineaDesglose.fechaActualizacionInterna) + "=getdate() " +
                                        " WHERE " +
                                            nameof(CTA_InformesContablesLineaDesglose.id) + "=@id";
                //Parametros
                object[] arr_Parametros_Update = new object[]
                {
                    new SqlParameter("@id", _lng_id)
                };
                #endregion

                //Update
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Actualizar_FechaActualizacionInterna), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        public void Actualizar_Lineas(long _lng_idInformeContableLinea, long _lng_idInformeContableLineaDesglose_Obviar, int _int_Linea)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                #region Update
                string str_SQL_Update = " UPDATE " + nameof(CTA_InformesContablesLineaDesglose) +
                                            " SET " +
                                                nameof(CTA_InformesContablesLineaDesglose.linea) + "=(" + nameof(CTA_InformesContablesLineaDesglose.linea) + " + 1), " +
                                                nameof(CTA_InformesContablesLineaDesglose.fechaActualizacionInterna) + "=getdate() " +
                                        " WHERE " +
                                            nameof(CTA_InformesContablesLineaDesglose.idInformeContableLinea) + "=@idInformeContableLinea AND " +
                                            nameof(CTA_InformesContablesLineaDesglose.id) + "<>@id AND " +
                                            nameof(CTA_InformesContablesLineaDesglose.linea) + ">=@linea";
                //Parametros
                object[] arr_Parametros_Update = new object[]
                {
                    new SqlParameter("@idInformeContableLinea", _lng_idInformeContableLinea),
                    new SqlParameter("@id", _lng_idInformeContableLineaDesglose_Obviar),
                    new SqlParameter("@linea", _int_Linea)
                };
                #endregion

                //Update
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Actualizar_Lineas), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                CTA_InformesContablesLineaDesglose mdl_CTA_InformesContablesLineaDesglose_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_CTA_InformesContablesLineaDesglose_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CTA_InformesContablesLineaDesglose) +
                                                " SET " +
                                                nameof(CTA_InformesContablesLineaDesglose.fechaBorrado) + "=@fechaBorrado, " +
                                                nameof(CTA_InformesContablesLineaDesglose.fechaActualizacionInterna) + "=getdate() " +
                                            " WHERE " +
                                                nameof(CTA_InformesContablesLineaDesglose.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                                new SqlParameter("@fechaBorrado",  DateTime.Now),
                            new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Grabar un registro de trazabilidad con los datos de la trasaccion realizada
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTA_InformesContablesLineaDesglose), null, mdl_CTA_InformesContablesLineaDesglose_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);

                }

                //Devolver tambien el Objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;
  
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<long> lst_idInformeContableLinea = (List<long>)_mdl_obj;

                if (lst_idInformeContableLinea != null & lst_idInformeContableLinea.Count > 0)
                {
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    string str_Filtro_IDs = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_idInformeContableLinea);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CTA_InformesContablesLineaDesglose) +
                                                " SET " +
                                                nameof(CTA_InformesContablesLineaDesglose.fechaBorrado) + "=@fechaBorrado, " +
                                                nameof(CTA_InformesContablesLineaDesglose.fechaActualizacionInterna) + "=getdate() " +
                                            " WHERE " + nameof(CTA_InformesContablesLineaDesglose.id) + " in (" + str_Filtro_IDs + ")";
                    //Parametros
                    lst_Parametros.Add(new SqlParameter("@fechaBorrado", DateTime.Now));
                    object[] arr_Parametros = lst_Parametros.ToArray();
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros);

                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaDesglose_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

    }

}
